//+------------------------------------------------------------------+
//|                                                    MyFirstEA.mq4 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property version   "1.00"
#property strict  
#include <stderror.mqh>
//--- input parameters//

input int      TakeProfit=50;
input int      StopLoss=50;
input double   LotSize=0.1;
input int Slippage=30;
input int MagicNumber=1234;    
double MyPoint;

double MA;
//--- indicator inputs
sinput string        indi = "";                // ------ Indicators -----
input int            MA_Period  = 200;         // MA Period
input ENUM_MA_METHOD MA_Method  = MODE_SMA;    // MA Method
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
    
   MyPoint = MyPoint();
   	
	  
   return(INIT_SUCCEEDED);
  }

  
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(TotalOpenOrders() == 0 && IsNewBar() == true)  

      InitIndicators();
     
      if(Close[1]>Open[1] && Close[2]>Open[2] && Close[3]>Open[3])
     { //Open Buy Order
      int buyticket=OrderSend(_Symbol,OP_BUY,LotSize,Ask,Slippage,0,0,"BUY",MagicNumber,0,clrNONE);
      if(buyticket<0)
        {
         Print("OrderSend failed with error #",GetLastError());
        }
      else
        {
         Print("OrderSend placed successfully");
        }

      bool res=OrderModify(buyticket,OrderOpenPrice(),Ask-StopLoss*MyPoint,Ask+TakeProfit*MyPoint,0,Blue);
      if(!res)
        {
         Print("Error in OrderModify. Error code=",GetLastError());
        }
      else
        {         
         
         Print("Order modified successfully.");
        }
     }
    if(Close[1]<Open[1] && Close[2]<Open[2] && Close[3]<Open[3])
     { //Open Sell Order
      int sellticket=OrderSend(_Symbol,OP_SELL,LotSize,Bid,Slippage,0,0,"SELL",MagicNumber,0,clrNONE);
      if(sellticket<0)
        {
         Print("OrderSend failed with error #",GetLastError());
        }
      else
        {
         Print("OrderSend placed successfully");
        }

      // Modify Sell Order
      bool res=OrderModify(sellticket,OrderOpenPrice(),Bid+StopLoss*MyPoint,Bid-TakeProfit*MyPoint,0,Blue);
      if(!res)
        {
         Print("Error in OrderModify. Error code=",GetLastError());
        }
      else
        {         //Open Sell Order
        
         Print("Order modified successfully.");
        }
     }   
      
   
  }   
  
      
// Get My Points   
double MyPoint()
{
   double CalcPoint = 0;
   
   if(_Digits == 2 || _Digits == 3) CalcPoint = 0.01;
   else if(_Digits == 4 || _Digits == 5) CalcPoint = 0.0001;
   
   return(CalcPoint);
}


// Get My Slippage

  
//Check if there is a new bar
bool IsNewBar()   
{        
      static datetime RegBarTime=0;
      datetime ThisBarTime = Time[0];

      if (ThisBarTime == RegBarTime)
      {
         return(false);
      }
      else
      {
         RegBarTime = ThisBarTime;
         return(true);
      }
}   
// Returns the number of total open orders for this Symbol and MagicNumber
int TotalOpenOrders()
{
   int total_orders = 0;

   for(int order = 0; order < OrdersTotal(); order++) 
   {
      if(OrderSelect(order,SELECT_BY_POS,MODE_TRADES)==false) break;

      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == _Symbol)break;
         
         
         
   }

   return(total_orders);
}
//Initialize Indicators
void InitIndicators()
  {
   MA=iMA(NULL,0,MA_Period,0,MA_Method,PRICE_CLOSE,1);
  }
// Buy Logic
bool BuySignal()
{
   if(Low[1] >= MA)
   {
      return(true);
   }
   else
   {
      return(false);
   }
}


// Sell Logic
bool SellSignal()
{
   if( High[1] <= MA)
   {
      return(true);
   }
   else
   {
      return(false);
   }
}

void exitsells()
{
	for (int i=OrdersTotal()-1; i >=0; i--)
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
			if (OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber)
			{
				while(true)//infinite loop must be escaped by break
				{
					bool result = OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);//actual order closing
					if (result != true)//if it did not close
					{
						  Print("LastError = ",GetLastError());//get the reason why it didn't close
					}
				
			}
		}
		else Print( "When selecting a trade, error ",GetLastError()," occurred");
	}
}
}   
    
  
     

   
   





